# Reference

<!-- DO NOT EDIT: This document was generated by Puppet Strings -->

## Table of Contents

### Resource types

* [`dsc_xmysqldatabase`](#dsc_xmysqldatabase): The DSC xMySqlDatabase resource type. Automatically generated from version 2.1.0.0
* [`dsc_xmysqlgrant`](#dsc_xmysqlgrant): The DSC xMySqlGrant resource type. Automatically generated from version 2.1.0.0
* [`dsc_xmysqlprovision`](#dsc_xmysqlprovision): The DSC  resource type. Automatically generated from version 2.1.0.0
* [`dsc_xmysqlserver`](#dsc_xmysqlserver): The DSC xMySqlServer resource type. Automatically generated from version 2.1.0.0
* [`dsc_xmysqluser`](#dsc_xmysqluser): The DSC xMySqlUser resource type. Automatically generated from version 2.1.0.0

## Resource types

### <a name="dsc_xmysqldatabase"></a>`dsc_xmysqldatabase`

The DSC xMySqlDatabase resource type.
Automatically generated from version 2.1.0.0

#### Properties

The following properties are available in the `dsc_xmysqldatabase` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Should the database be present or absent.

##### `dsc_mysqlversion`

Data type: `String`

MYSql Version Number

#### Parameters

The following parameters are available in the `dsc_xmysqldatabase` type.

* [`dsc_databasename`](#dsc_databasename)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_rootcredential`](#dsc_rootcredential)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_databasename"></a>`dsc_databasename`

namevar

Data type: `String`

Name of the database.

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_rootcredential"></a>`dsc_rootcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

The root credential that is used to install MySql server.

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xmysqlgrant"></a>`dsc_xmysqlgrant`

The DSC xMySqlGrant resource type.
Automatically generated from version 2.1.0.0

#### Properties

The following properties are available in the `dsc_xmysqlgrant` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Ensure given grant to mySql database present or absent.

##### `dsc_mysqlversion`

Data type: `String`

MYSql Version Number

#### Parameters

The following parameters are available in the `dsc_xmysqlgrant` type.

* [`dsc_databasename`](#dsc_databasename)
* [`dsc_permissiontype`](#dsc_permissiontype)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_rootcredential`](#dsc_rootcredential)
* [`dsc_username`](#dsc_username)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_databasename"></a>`dsc_databasename`

namevar

Data type: `String`

MySql database name to grant permissions.

##### <a name="dsc_permissiontype"></a>`dsc_permissiontype`

namevar

Data type: `Enum['ALL PRIVILEGES', 'CREATE', 'DROP', 'DELETE', 'INSERT', 'SELECT', 'UPDATE', 'EXECUTE']`

MySql user permission type.

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_rootcredential"></a>`dsc_rootcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

MySql connection credential used for the root.

##### <a name="dsc_username"></a>`dsc_username`

namevar

Data type: `String`

Name of MySQL user.

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xmysqlprovision"></a>`dsc_xmysqlprovision`

The DSC  resource type.
Automatically generated from version 2.1.0.0

#### Properties

The following properties are available in the `dsc_xmysqlprovision` type.

##### `dsc_port`

Data type: `Optional[String]`

 

##### `dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

#### Parameters

The following parameters are available in the `dsc_xmysqlprovision` type.

* [`dsc_databasename`](#dsc_databasename)
* [`dsc_downloaduri`](#dsc_downloaduri)
* [`dsc_mysqlversion`](#dsc_mysqlversion)
* [`dsc_permissiontype`](#dsc_permissiontype)
* [`dsc_rootcredential`](#dsc_rootcredential)
* [`dsc_usercredential`](#dsc_usercredential)
* [`dsc_username`](#dsc_username)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_databasename"></a>`dsc_databasename`

namevar

Data type: `String`

 

##### <a name="dsc_downloaduri"></a>`dsc_downloaduri`

namevar

Data type: `String`

 

##### <a name="dsc_mysqlversion"></a>`dsc_mysqlversion`

namevar

Data type: `String`

 

##### <a name="dsc_permissiontype"></a>`dsc_permissiontype`

namevar

Data type: `Array[String]`

 

##### <a name="dsc_rootcredential"></a>`dsc_rootcredential`

namevar

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_usercredential"></a>`dsc_usercredential`

namevar

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_username"></a>`dsc_username`

namevar

Data type: `String`

 

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xmysqlserver"></a>`dsc_xmysqlserver`

The DSC xMySqlServer resource type.
Automatically generated from version 2.1.0.0

#### Properties

The following properties are available in the `dsc_xmysqlserver` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Ensure server is present or absent

##### `dsc_port`

Data type: `Optional[String]`

The port number for the service

#### Parameters

The following parameters are available in the `dsc_xmysqlserver` type.

* [`dsc_mysqlversion`](#dsc_mysqlversion)
* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_rootpassword`](#dsc_rootpassword)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_mysqlversion"></a>`dsc_mysqlversion`

namevar

Data type: `String`

mySql Version Number

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_rootpassword"></a>`dsc_rootpassword`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

The root credential that is used to install mySql server.

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

### <a name="dsc_xmysqluser"></a>`dsc_xmysqluser`

The DSC xMySqlUser resource type.
Automatically generated from version 2.1.0.0

#### Properties

The following properties are available in the `dsc_xmysqluser` type.

##### `dsc_ensure`

Data type: `Optional[Enum['Present', 'Absent']]`

Ensure MySQL user is present or absent.

##### `dsc_mysqlversion`

Data type: `String`

MySQL Version Number

#### Parameters

The following parameters are available in the `dsc_xmysqluser` type.

* [`dsc_psdscrunascredential`](#dsc_psdscrunascredential)
* [`dsc_rootcredential`](#dsc_rootcredential)
* [`dsc_usercredential`](#dsc_usercredential)
* [`dsc_username`](#dsc_username)
* [`name`](#name)
* [`validation_mode`](#validation_mode)

##### <a name="dsc_psdscrunascredential"></a>`dsc_psdscrunascredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

 

##### <a name="dsc_rootcredential"></a>`dsc_rootcredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

MySQL root credential used to create a user.

##### <a name="dsc_usercredential"></a>`dsc_usercredential`

Data type: `Optional[Struct[{ user => String[1], password => Sensitive[String[1]] }]]`

Credential for MySQL user.

##### <a name="dsc_username"></a>`dsc_username`

namevar

Data type: `String`

Name of MySQL user to create or remove.

##### <a name="name"></a>`name`

namevar

Data type: `String`

Description of the purpose for this resource declaration.

##### <a name="validation_mode"></a>`validation_mode`

Data type: `Enum[property, resource]`

Whether to check if the resource is in the desired state by property (default) or using Invoke-DscResource in Test mode
(resource).

Default value: `property`

